## vlc 0.8.4

=== bindings/python/Makefile ===
ifdef HOMEDRIVE
	COMPILERARG = --compiler=mingw32
else
	COMPILERARG = 
endif

all:
	python setup.py build $(COMPILERARG)

install:
	python setup.py install

clean:
	$(RM) -rf build
